Subject: Formal definition of LDAPOID values

From: "Jim Sermersheim" <[email-masked]>
Date: Tue, 23 Jan 2001 12:44:35 -0700

This is the proposal to add a formal ABNF for the value of LDAPOID to section 4.1.2 of the protocol specification. Currently, there is only an example in this section to be used as a reference for the actual string encoding. The intent of this ABNF is to clairify, using a formal definition, as well as to be a reference for other areas in the specification needing to refer to the string representation of LDAPOID.

The proposed change is this:

<The LDAPOID is a notational convenience to indicate that the permitted value of this string is a (UTF-8 encoded) dotted-decimal representation of an OBJECT IDENTIFIER.
<
<LDAPOID ::= OCTET STRING
<
<For example,
<
<1.3.6.1.4.1.1466.1.2.3

>The LDAPOID is a notational convenience to indicate that the permitted value of this string is a (UTF-8 encoded) dotted-decimal representation of an OBJECT IDENTIFIER.
>
>LDAPOID ::= OCTET STRING
>
>A value of LDAPOID is based on the following ABNF [RFC2234] (lines wrapped for readability):
>
>	ldapOID = numericstring *( "." numericstring )
>
>	numericstring = 1*( "0" / "1" / "2" / "3" / "4" /
>                          "5" / "6" / "7" / "8" / "9" )
>
>For example,
>
>1.3.6.1.4.1.1466.1.2.3

Potential issues include the fact that the "oid." prefix is not accounted for, and the ABNF does not ensure a valid OID (within the existing OID hierarchy). I don't believe either of these issues are valid.

Is this reasonable, and will it work?

Jim

---

From: "Steven Legg" <[email-masked]>
Date: Wed, 24 Jan 2001 13:30:13 +1100

Jim,

Is there some reason why you can't just reference the numericstring
production
in Section 4.1 of RFC 2252 ?

If not, then like RFC 2252, you should say that leading zeroes are not
permitted in a numericstring, or else rewrite the ABNF to disallow them,
e.g.

numericstring  = "0" / ( non-zero-digit *digit)
digit          = %x30-39 ; "0" to "9"
non-zero-digit = %x31-39 ; "1" to "9"

Regards,
Steven

> -----Original Message-----
> From: [email-masked]
> [mailto:[email-masked]]On Behalf Of Jim Sermersheim
> Sent: Wednesday, 24 January 2001 6:45
> To: [email-masked]; [email-masked]
> Subject: Formal definition of LDAPOID values
>
>
> This is the proposal to add a formal ABNF for the value of
> LDAPOID to section 4.1.2 of the protocol specification.
> Currently, there is only an example in this section to be
> used as a reference for the actual string encoding. The
> intent of this ABNF is to clairify, using a formal
> definition, as well as to be a reference for other areas in
> the specification needing to refer to the string
> representation of LDAPOID.
>
> <The LDAPOID is a notational convenience to indicate that the
> permitted value of this string is a (UTF-8 encoded)
> dotted-decimal representation of an OBJECT IDENTIFIER.
> <
> >The LDAPOID is a notational convenience to indicate that the
> permitted value of this string is a (UTF-8 encoded)
> dotted-decimal representation of an OBJECT IDENTIFIER.
> >
> >LDAPOID ::= OCTET STRING
> >
> Potential issues include the fact that the "oid." prefix is
> not accounted for, and the ABNF does not ensure a valid OID
> (within the existing OID hierarchy). I don't believe either
> of these issues are valid.
>

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Tue, 23 Jan 2001 19:02:46 -0800

>in Section 4.1 of RFC 2252 ?

IMO, the reference should be the other way around.  Excepting DNs and
URLs, I belive RFC 2251 should detail syntaxes used directly
in the protocol.  RFC 2252 should define attribute type syntaxes,
pulling in whatever protocol syntaxes it needs to do this by reference.

>permitted in a numericstring, or else rewrite the ABNF to disallow them,

I concur.

>non-zero-digit = %x31-39 ; "1" to "9"

I suggest:
        numericoid = numericstring *( DOT numericstring )
        numericstring = DIGIT / ( LEADDIGIT 1*DIGIT )
        DIGIT = %x30-39 ;  "0"-"9" (digits)
        LEADDIGIT = 0x31-39 ; "1"-"9" (leading digits)
        DOT = %x2E ; "." (period)

Kurt

---

From: "Steven Legg" <[email-masked]>
Date: Wed, 24 Jan 2001 14:54:47 +1100

> [mailto:[email-masked]]On Behalf Of Kurt D. Zeilenga
> Sent: Wednesday, 24 January 2001 14:03
> To: [email-masked]
> Cc: 'Jim Sermersheim'; [email-masked]
> Subject: RE: Formal definition of LDAPOID values
> 
> 
> IMO, the reference should be the other way around.

I agree.

Cheers,
Steven